subroutine bicg(length,tol,A,b,x)

    integer, intent(in)             :: length
    real(kind(1.d0)), intent(in)    :: tol
    real(kind(1.d0)), intent(in)    :: A(length,length)
    real(kind(1.d0)), intent(in)    :: b(length)
    real(kind(1.d0)), intent(inout) :: x(length)
    real(kind(1.d0)) :: A_(length,length)
    real(kind(1.d0)) :: r(length), r_(length)
    real(kind(1.d0)) :: p(length), p_(length)
    real(kind(1.d0)) :: tmpV(length), tmpV_(length)
    real(kind(1.d0)) :: alpha, beta, norm, tmp1, tmp2
    real(kind(1.d0)) :: dotProd, dotProdOld   
    integer          :: j
    
    call OMP_SET_NUM_THREADS(2)
    !$OMP PARALLEL   
    !$OMP SECTIONS
    !$OMP SECTION
    A_ = transpose(A)
    !$OMP SECTION
    r  = b -matmul(A,x)
    r_ = r
    p  = r
    p_ = r
    !$OMP END SECTIONS
    !$OMP END PARALLEL

    dotProdOld = dot_product(r,r_)
    !
    !loop...
    !
end subroutine bicg