void gaussSeidelRedBlack(double omega,
     const DistributedVector &f, DistributedVector &u) {
        const DistributedVector::Grid &F = f.grid;
        DistributedVector::Grid       &U = u.grid;   
        double c   = omega/4.;
        double hh  = 1./((u.N+1)*(u.N+1));
        // ghost nodes ...
        // red nodes ...
        u.updateBoundary();
        // black nodes ...
        u.updateBoundary();
        // ghost nodes ...
        int    rhh = (u.N+1)*(u.N+1);
        double s   = sum(u)/rhh;
        for (int i=0; i<=u.m; ++i) {
         for (int j=0; j<=u.n; ++j) {
             U(i,j) -= s;
         } }
    }