subroutine bicg(gSize,lSize,mpiSize,rank,tol,A,A_,b,x)

    integer, intent(in)             :: gSize,lSize,rank,mpiSize
    real(kind(1.d0)), intent(in)    :: tol
    real(kind(1.d0)), intent(in)    :: A(lSize,gSize),A_(lSize,gSize)
    real(kind(1.d0)), intent(in)    :: b(lSize)
    real(kind(1.d0)), intent(inout) :: x(lSize)
    !
    real(kind(1.d0)) :: r(lSize), r_(lSize)
    real(kind(1.d0)) :: p(gSize), p_(gSize)
    real(kind(1.d0)) :: tmpV(lSize), tmpV_(lSize)
    real(kind(1.d0)) :: alpha, beta, norm, tmp1, tmp2
    real(kind(1.d0)) :: dotProd, dotProdOld   
    integer          :: i,j, ierror, si, ei
    
    si        = (rank*lSize)+1
    ei        = (rank+1)*lSize
    r         = b 
    r_        = r
    p(si:ei)  = r
    p_(si:ei) = r

    do i=0,mpiSize-1     !update p, p_
        CALL MPI_BCAST(p((i*lSize)+1:((i+1)*lSize)), lSize, &
                    MPI_DOUBLE_PRECISION, i, MPI_COMM_WORLD, ierror)
        CALL MPI_BCAST(p_((i*lSize)+1:((i+1)*lSize)), lSize, &
                    MPI_DOUBLE_PRECISION, i, MPI_COMM_WORLD, ierror)
    end do
    dotProdOld = dot_product(r,r_)
!...
