program bicgtest
use mpi
implicit none
integer :: ierror,rank,mpiSize,gSize,lSize,alloc_status,&
           dealloc_status, n_p_sec, ia, ie, i,j,&
           status(MPI_STATUS_SIZE)
real(kind(1.d0))   :: tol,t
real(kind(1.d0)), allocatable, dimension (:,:) :: A, A_
real(kind(1.d0)), allocatable, dimension (:)   :: x, b, sol

    gSize = 100
    !init stop-time
    call system_clock(count_rate=n_p_sec)!
    call system_clock(count=ia)

    !init mpi
    call MPI_INIT(ierror)
    call MPI_COMM_SIZE(MPI_COMM_WORLD, mpiSize, ierror)
    call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierror)

    lSize = gSize/mpiSize
    tol = 0.001

    allocate(A(lSize,gSize),stat=alloc_status)
    allocate(A_(lSize,gSize),stat=alloc_status)
    allocate(x(lSize),stat=alloc_status)
    allocate(b(lSize),stat=alloc_status)
    allocate(sol(gSize),stat=alloc_status)
    !...