MpiCart(const MpiCart &rhs)
 : comm(rhs.comm), numRows(rhs.numRows), 
 numCols(rhs.numCols), row(rhs.row), col(rhs.col)
{
  for (int k=0; k<8; ++k) {
    neighbors[k] = rhs.neighbors[k];
  }
}

int cartRank(int row, int col) {
  if ((row<0) || (col<0) || (row==numRows) 
              || (col==numCols)) {
    return MPI_PROC_NULL;
  }
  int coords[2];
  coords[0] = row;
  coords[1] = col;
  return comm.Get_cart_rank(coords);
}