MpiCart(int _numRows, int _numCols)
  : numRows(_numRows), numCols(_numCols){
  int  dims[2];  bool periods[2];

   // create mpi_cart:  2-dimensional, 2 x 2,non-periodic
  dims[0]    = numRows; dims[1]    = numCols;
  periods[0] = false;   periods[1] = false;
  comm = MPI::COMM_WORLD.Create_cart(2,dims,periods,true);
  
  // find your position in the cart
  rank = MPI::COMM_WORLD.Get_rank();
  int coords[2];
  comm.Get_coords(rank, 2, coords);
  row = coords[0]; col = coords[1];
  
  // find your neighbors
  comm.Shift(0, 1, neighbors[North], neighbors[South]);
  comm.Shift(1, 1, neighbors[West],  neighbors[East]);
}