program bicgtest

integer, parameter :: length = 400
real(kind(1.d0))   :: tol
real(kind(1.d0))   :: A(length,length)
real(kind(1.d0))   :: x(length),b(length)
integer            :: n_p_sec, ia, ie, i,j

call system_clock(count_rate=n_p_sec)!
call initMatrixandVectors(length, A, x, b)
tol = 0.001

call system_clock(count=ia)
call bicg(length,tol,A,b,x)
call system_clock(count=ie)

write(*,*) ((ie-ia)/real(n_p_sec))

end program bicgtest