!...
    do j=1,gSize
        if(dot_product(r,r) < tol) then
            return
        end if
        tmpV  = matmul(A,p)
        tmpV_ = matmul(A_,p_)
        tmp2  = dot_product(tmpV, p_(si:ei))
        !reduce tmp2
        call MPI_ALLREDUCE( tmp2, tmp2, 1, MPI_DOUBLE_PRECISION, &
                            MPI_SUM, MPI_COMM_WORLD, ierror)
        alpha = dotProdOld/tmp2
        x  = x  + alpha*p(si:ei)
        r  = r  - alpha*tmpV
        r_ = r_ - alpha*tmpV_
        dotProd    = dot_product(r,r_)
        !reduce dotProd
        call MPI_ALLREDUCE( dotProd, dotProd, 1, MPI_DOUBLE_PRECISION, &
                            MPI_SUM, MPI_COMM_WORLD, ierror)
        beta       = dotProd/dotProdOld
        dotProdOld = dotProd
        p(si:ei)  = r  + beta*p(si:ei)
        p_(si:ei) = r_ + beta*p_(si:ei)
        !update p, p_
        do i=0,mpiSize-1
            CALL MPI_BCAST(p((i*lSize)+1:((i+1)*lSize)), lSize, &
                       MPI_DOUBLE_PRECISION, i, MPI_COMM_WORLD, ierror)
            CALL MPI_BCAST(p_((i*lSize)+1:((i+1)*lSize)), lSize, &
                       MPI_DOUBLE_PRECISION, i, MPI_COMM_WORLD, ierror)
        end do
    end do
end subroutine bicg